grade = {};

function grade.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Cultivator, specializations);
end;
function grade:load(xmlFile)
            print("'lua loaded '" );	
	self.drumNodeLeft1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index1"));
	self.drumNodeLeft2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index2"));
	self.drumNodeLeft3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index3"));
	self.drumNodeRight1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index4"));
	self.drumNodeRight2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index5"));
	self.drumNodeRight3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index6"));
	self.drumRotationScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.drum#rotationScale"), 1);
   
	
	local rotationPartNodeRight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartR#index"));
    if rotationPartNodeRight ~= nil then
        self.rotationPartR = {};
        self.rotationPartR.node = rotationPartNodeRight;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartR#minRot"));
        self.rotationPartR.minRot = {};
        self.rotationPartR.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartR.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartR.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartR#maxRot"));
        self.rotationPartR.maxRot = {};
        self.rotationPartR.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartR.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartR.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        self.rotationPartR.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartR#rotTime"), 100)*1000;
        self.rotationPartR.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartR#touchRotLimit"), 10));
    end;
	
	
	local rotationPartNodeLeft = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartL#index"));
    if rotationPartNodeLeft ~= nil then
        self.rotationPartL = {};
        self.rotationPartL.node = rotationPartNodeLeft;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartL#minRot"));
        self.rotationPartL.minRot = {};
        self.rotationPartL.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartL.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartL.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartL#maxRot"));
        self.rotationPartL.maxRot = {};
        self.rotationPartL.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPartL.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPartL.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        self.rotationPartL.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartL#rotTime"), 100)*1000;
        self.rotationPartL.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartL#touchRotLimit"), 10));
    end;


	local rotationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart#index"));
    if rotationPartNode ~= nil then
        self.rotationPart = {};
        self.rotationPart.node = rotationPartNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart#minRot"));
        self.rotationPart.minRot = {};
        self.rotationPart.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPart.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPart.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart#maxRot"));
        self.rotationPart.maxRot = {};
        self.rotationPart.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPart.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPart.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        self.rotationPart.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart#rotTime"), 100)*1000;
        self.rotationPart.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart#touchRotLimit"), 10));
    end;
	
	
	local rotationPartNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart1#index"));
    if rotationPartNode1 ~= nil then
        self.rotationPart1 = {};
        self.rotationPart1.node = rotationPartNode1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart1#minRot"));
        self.rotationPart1.minRot = {};
        self.rotationPart1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPart1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPart1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart1#maxRot"));
        self.rotationPart1.maxRot = {};
        self.rotationPart1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 180));
        self.rotationPart1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 180));
        self.rotationPart1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 180));

        self.rotationPart1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart1#rotTime"), 100)*1000;
        self.rotationPart1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart1#touchRotLimit"), 10));
    end;	
	
	local translationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart#index"));
    if translationPartNode ~= nil then
        self.translationPart = {};
        self.translationPart.node = translationPartNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#minTrans"));
        self.translationPart.minTrans = {};
        self.translationPart.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#maxTrans"));
        self.translationPart.maxTrans = {};
        self.translationPart.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#transTime"), 2)*1000;
        self.translationPart.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#touchTransLimit"), 10);
    end;
	
	local translationPartNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart2#index"));
    if translationPartNode2 ~= nil then
        self.translationPart2 = {};
        self.translationPart2.node = translationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#minTrans"));
        self.translationPart2.minTrans = {};
        self.translationPart2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#maxTrans"));
        self.translationPart2.maxTrans = {};
        self.translationPart2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#transTime"), 2)*1000;
        self.translationPart2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#touchTransLimit"), 10);
    end;
	
	local workSound = getXMLString(xmlFile, "vehicle.workSound#file");
    if workSound ~= nil and workSound ~= "" then
        self.workSound = createSample("workSound");
        loadSample(self.workSound, workSound, false);
    end;
	
	local translationPartNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart3#index"));
    if translationPartNode3 ~= nil then
        self.translationPart3 = {};
        self.translationPart3.node = translationPartNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#minTrans"));
        self.translationPart3.minTrans = {};
        self.translationPart3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#maxTrans"));
        self.translationPart3.maxTrans = {};
        self.translationPart3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#transTime"), 2)*1000;
        self.translationPart3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#touchTransLimit"), 10);
    end;
	

	self.rotationMaxRight = true;
	self.rotationMaxLeft = true;
	self.rotationMax = true;
	self.rotationMax1 = true;
	self.translationMax2 = false;
	self.translationMax3 = true;
	 
end;

function grade:delete()
end;


function grade:mouseEvent(posX, posY, isDown, isUp, button)
end;

function grade:keyEvent(unicode, sym, modifier, isDown)
	
	if sym == Input.KEY_k then
		print("max")
		self.translationMax = isDown;
	end;
	if sym == Input.KEY_m then
		print("min")
		self.translationMin = isDown;
	end;
	
	if isDown and sym == Input.KEY_x then
		self.rotationMaxRight = not self.rotationMaxRight;
		self.rotationMaxLeft = not self.rotationMaxLeft;
		self.rotationMax = not self.rotationMax;
		self.rotationMax1 = not self.rotationMax1;
	end;
	
	if isDown and sym == Input.KEY_b then
		self.translationMax2 = not self.translationMax2;
	end;	
end;


function grade:update(dt)
	
	if self.attacherVehicle then
	
		self.isExpandedRight = false;
        if self.rotationPartR ~= nil then
            local x, y, z = getRotation(self.rotationPartR.node);
            local minRot = self.rotationPartR.minRot;
            local eps = self.rotationPartR.touchRotLimit;

            if math.abs(x-minRot[1]) < eps and math.abs(y-minRot[2]) < eps and math.abs(z-minRot[3]) < eps then
                self.isExpandedRight = true;
            end;
        end;
			
	
		if self.translationMax2 and self.isExpandedRight and self.attacherVehicle.lastSpeed*3600 > 2 then
			if not self.workSoundRunning then
                print("start");
                playSample(self.workSound, 0, 1.6, 0);
                self.workSoundRunning = true;
			end;
		end;
		
		if not self.translationMax2 or not self.isExpandedRight or self.attacherVehicle.lastSpeed*3600 < 2 then
			if self.workSoundRunning then
                print("end");
                stopSample(self.workSound, 0, 1.6, 0);
                self.workSoundRunning = false;
			end;
			
			Utils.setEmittingState(self.threshingParticleSystems1, false);
			Utils.setEmittingState(self.threshingParticleSystems2, false);
			Utils.setEmittingState(self.threshingParticleSystems3, false);
			Utils.setEmittingState(self.threshingParticleSystems4, false);
			Utils.setEmittingState(self.threshingParticleSystems5, false);
			Utils.setEmittingState(self.threshingParticleSystems6, false);
			Utils.setEmittingState(self.threshingParticleSystems7, false);
			Utils.setEmittingState(self.threshingParticleSystems8, false);
			Utils.setEmittingState(self.threshingParticleSystems9, false);
			Utils.setEmittingState(self.threshingParticleSystems10, false);
			Utils.setEmittingState(self.threshingParticleSystems11, false);
			Utils.setEmittingState(self.threshingParticleSystems12, false);
			Utils.setEmittingState(self.threshingParticleSystems13, false);
			Utils.setEmittingState(self.threshingParticleSystems14, false);
			Utils.setEmittingState(self.threshingParticleSystems15, false);
			Utils.setEmittingState(self.threshingParticleSystems16, false);
		end;
	end;
	
		
	local doTranslate = self.translationMax or self.translationMin
		if self.translationPart ~= nil and doTranslate then
	
        local x, y, z = getTranslation(self.translationPart.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart.maxTrans, self.translationPart.minTrans, 3, self.translationPart.transTime, dt, not self.translationMax);
        setTranslation(self.translationPart.node, unpack(newTrans));
		end;

	if self.rotationPartR ~= nil then
        local x, y, z = getRotation(self.rotationPartR.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartR.maxRot, self.rotationPartR.minRot, 3, self.rotationPartR.rotTime, dt, not self.rotationMaxRight);
        setRotation(self.rotationPartR.node, unpack(newRot));
    end;

    if self.rotationPartL ~= nil then
        local x, y, z = getRotation(self.rotationPartL.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartL.maxRot, self.rotationPartL.minRot, 3, self.rotationPartL.rotTime, dt, not self.rotationMaxLeft);
        setRotation(self.rotationPartL.node, unpack(newRot));
    end;
	
    if self.rotationPart ~= nil then
        local x, y, z = getRotation(self.rotationPart.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart.maxRot, self.rotationPart.minRot, 3, self.rotationPart.rotTime, dt, not self.rotationMax);
        setRotation(self.rotationPart.node, unpack(newRot));
    end;

    if self.rotationPart1 ~= nil then
        local x, y, z = getRotation(self.rotationPart1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart1.maxRot, self.rotationPart1.minRot, 3, self.rotationPart1.rotTime, dt, not self.rotationMax1);
        setRotation(self.rotationPart1.node, unpack(newRot));
    end;

	if self.translationMax2 ~= nil then
		local x, y, z = getTranslation(self.translationPart2.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart2.maxTrans, self.translationPart2.minTrans, 3, self.translationPart2.transTime, dt, not self.translationMax2);
        setTranslation(self.translationPart2.node, unpack(newTrans));
	end;
	
	if self.translationMax3 ~= nil then
		local x, y, z = getTranslation(self.translationPart3.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart3.maxTrans, self.translationPart3.minTrans, 3, self.translationPart3.transTime, dt, not self.translationMax3);
        setTranslation(self.translationPart3.node, unpack(newTrans));
	end;
end;

function grade:draw()
	
	if self.rotationMaxLeft then
		g_currentMission:addExtraPrintText("Press X: Work mode");
	else
		g_currentMission:addExtraPrintText("Press X: Transport mode");
	end;
	
end;




