-- lelymower
-- Henly20 (ls-uk Modteam)
-- 24/07/2010
-- www.ls-uk.info

lelymower = {};

function lelymower.prerequisitesPresent(specializations)
    return true;
end;

function lelymower:load(xmlFile)


	self.rotor = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotor#index"));
	
	self.drumNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index"));
	self.drumNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index2"));
	self.drumNode3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index3"));
	self.drumNode4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index4"));
	self.drumNode5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index5"));
	self.drumNode6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index6"));
	self.drumNode7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index7"));
	self.drumNode8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index8"));
	self.drumNode9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index9"));
	self.drumNode10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index10"));
	self.drumNode11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index11"));
	
	self.drumRotationScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.drum#rotationScale"), 1);

  self.particleSystems = {};
    local i = 0;
    while true do
        local namei = string.format("vehicle.particleSystems.particleSystems(%d)", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
		if nodei == nil then
			break;
		end; 
        Utils.loadParticleSystem(xmlFile, self.particleSystems, namei, nodei, false, nil, self.baseDirectory)		
		i = i +1;		
    end;
    self.particleSystemsActive = false;

    self.groundReferenceThreshold = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.groundReferenceNode#threshold"), 0.2);
    self.groundReferenceNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.groundReferenceNode#index"));
    if self.groundReferenceNode == nil then
        self.groundReferenceNode = self.components[1].node;
    end;

    local mowerSound = getXMLString(xmlFile, "vehicle.mowerSound#file");
    if mowerSound ~= nil and mowerSound ~= "" then
        mowerSound = Utils.getFilename(mowerSound, self.baseDirectory); 
        self.mowerSound = createSample("mowerSound");
        self.mowerSoundEnabled = false;
        loadSample(self.mowerSound, mowerSound, false);
        self.mowerSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.mowerSound#pitchOffset"), 1);
        self.mowerSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.mowerSound#volume"), 1);
    end;

    local numCuttingAreas = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cuttingAreas#count"), 0);
    for i=1, numCuttingAreas do
        local areanamei = string.format("vehicle.cuttingAreas.cuttingArea%d", i);
        self.cuttingAreas[i].foldMinLimit = Utils.getNoNil(getXMLFloat(xmlFile, areanamei .. "#foldMinLimit"), 0);
        self.cuttingAreas[i].foldMaxLimit = Utils.getNoNil(getXMLFloat(xmlFile, areanamei .. "#foldMaxLimit"), 1);
    end;

    local numWindrowerDropAreas = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.windrowerDropAreas#count"), 0);
    if numWindrowerDropAreas ~= 1 or numWindrowerDropAreas ~= table.getn(self.cuttingAreas) then
        print("Warning: number of cutting areas and drop areas should be equal");
    end;
    self.windrowerDropAreas = {}
    for i=1, numWindrowerDropAreas do
        self.windrowerDropAreas[i] = {};
        local areanamei = string.format("vehicle.windrowerDropAreas.windrowerDropArea%d", i);
        self.windrowerDropAreas[i].start = Utils.indexToObject(self.components, getXMLString(xmlFile, areanamei .. "#startIndex"));
        self.windrowerDropAreas[i].width = Utils.indexToObject(self.components, getXMLString(xmlFile, areanamei .. "#widthIndex"));
        self.windrowerDropAreas[i].height = Utils.indexToObject(self.components, getXMLString(xmlFile, areanamei .. "#heightIndex"));
    end;

    self.isTurnedOn = false;

	local rotationPartNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart1#index"));
		if rotationPartNode1 ~= nil then
        self.rotationPart1 = {};
        self.rotationPart1.node = rotationPartNode1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart1#minRot"));
        self.rotationPart1.minRot = {};
        self.rotationPart1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart1#maxRot"));
        self.rotationPart1.maxRot = {};
        self.rotationPart1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart1#rotTime"), 2)*1000;
        self.rotationPart1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart1#touchRotLimit"), 10));
    end;
	local rotationPartNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart2#index"));
		if rotationPartNode2 ~= nil then
        self.rotationPart2 = {};
        self.rotationPart2.node = rotationPartNode2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#minRot"));
        self.rotationPart2.minRot = {};
        self.rotationPart2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#maxRot"));
        self.rotationPart2.maxRot = {};
        self.rotationPart2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#rotTime"), 2)*1000;
        self.rotationPart2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#touchRotLimit"), 10));
    end;

	self.setHydraulicDirection = SpecializationUtil.callSpecializationsFunction("setHydraulicDirection");
	
	local hydraulicsCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.hydraulics#count"), 0);	
	self.hydraulics = {};	
	for i=1, hydraulicsCount do
		local hydraulicName = string.format("vehicle.hydraulics.hydraulic%d", i);		
		self.hydraulics[i] = {};		
		self.hydraulics[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#index"));
		self.hydraulics[i].punch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punch"));
		self.hydraulics[i].translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punchFixpoint"));
		self.hydraulics[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#fixpoint"));	
		local xUp, yUp, zUp = Utils.getVectorFromString(Utils.getNoNil(getXMLString(xmlFile, hydraulicName .. "#upVectors"),"0 1 0"));
		self.hydraulics[i].upVectors = {xUp, yUp, zUp};
		
		local ax, ay, az;		
		if self.hydraulics[i].punch ~= nil then
			ax, ay, az = getWorldTranslation(self.hydraulics[i].punch);
		else
			ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
		end;
		if self.hydraulics[i].translationPunch ~= nil then
			local bx, by, bz = getWorldTranslation(self.hydraulics[i].translationPunch);		
			self.hydraulics[i].punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		end;
	end;
	self.setHydraulicTime = 30;
	
	local supportstandTranslationNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.supportstandTranslation#index"));
    if supportstandTranslationNode ~= nil then
        self.supportstandTranslation = {};
        self.supportstandTranslation.node = supportstandTranslationNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.supportstandTranslation#minTrans"));
        self.supportstandTranslation.minRot = {};
        self.supportstandTranslation.minRot[1] = x;
        self.supportstandTranslation.minRot[2] = y;
        self.supportstandTranslation.minRot[3] = z;

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.supportstandTranslation#maxTrans"));
        self.supportstandTranslation.maxRot = {};
        self.supportstandTranslation.maxRot[1] = x;
        self.supportstandTranslation.maxRot[2] = y;
        self.supportstandTranslation.maxRot[3] = z;

        self.supportstandTranslation.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.supportstandTranslation#transTime"), 2)*1000;
    end;
	
	self.supportstandActive = true;
	
	self.rotationMax1 = true;
	self.rotationMax2 = true;	
	self.wasToFast = false;
    self.wasToSlow = false;
end;

function lelymower:delete()

  Utils.setEmittingState(self.particleSystems)

    if self.mowerSound ~= nil then
        delete(self.mowerSound);
    end;

end;

function lelymower:mouseEvent(posX, posY, isDown, isUp, button)
end;

function lelymower:keyEvent(unicode, sym, modifier, isDown)

if isDown and sym == Input.KEY_x   then

		self.rotationMax1 = not self.rotationMax1;
		self.rotationMax2 = not self.rotationMax2;
	
	end;

	if isDown and sym==Input.KEY_b and self.rotationMax1 and self.rotationMax2 then
		self.isTurnedOn = not self.isTurnedOn;
	end;	
end;
		

function lelymower:update(dt)


    if self:getIsActive() then

		if self.attacherVehicle then
	
        if self.isTurnedOn and self.rotationMax1 and self.rotationMax2 then
		if self.drumNode1 ~= nil then
				rotate(self.drumNode1, self.drumRotationScale * 35 * 0, 15, 0);
			end;		
		if self.drumNode2 ~= nil then
				rotate(self.drumNode2, self.drumRotationScale * 35 * 0, 15, 0);
			end;	
		if self.drumNode3 ~= nil then
				rotate(self.drumNode3, self.drumRotationScale * 35 * 0, 15, 0);
			end;
		if self.drumNode4 ~= nil then
				rotate(self.drumNode4, self.drumRotationScale * 35 * 0, 15, 0);
			end;	
		if self.drumNode5 ~= nil then
				rotate(self.drumNode5, self.drumRotationScale * 35 * 0, 15, 0);
			end;	
		if self.drumNode6 ~= nil then
				rotate(self.drumNode6, self.drumRotationScale * 35 * 0, 15, 0);
			end;
		if self.drumNode7 ~= nil then
				rotate(self.drumNode7, self.drumRotationScale * 35 * 0, 15, 0);
			end;
		if self.drumNode8 ~= nil then
				rotate(self.drumNode8, self.drumRotationScale * 35 * 0, 15, 0);
			end;	
		if self.drumNode9 ~= nil then
				rotate(self.drumNode9, self.drumRotationScale * 35 * 0, 15, 0);
			end;	
		if self.drumNode10 ~= nil then
				rotate(self.drumNode10, self.drumRotationScale * 35 * 0, 15, 0);
			end;			
		if self.drumNode11 ~= nil then
				rotate(self.drumNode11, self.drumRotationScale * 5 * 1, 0, 0);
			end;				
		
	        local toFast = self:doCheckSpeedLimit() and self.lastSpeed*3600 > 35;
	        local toSlow = self:doCheckSpeedLimit() and self.lastSpeed*3600 < 1;
            if not toFast and not toSlow then
                local x,y,z = getWorldTranslation(self.groundReferenceNode);
                local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
                if terrainHeight+self.groundReferenceThreshold >= y then
                    local foldAnimTime = self.foldAnimTime;
                    local numDropAreas = table.getn(self.windrowerDropAreas);
                    local numAreas = table.getn(self.cuttingAreas);
                    local sum = 0;
                    local fruitType = FruitUtil.FRUITTYPE_GRASS;
                    local fruitTypeFix = false;
                    for k, cuttingArea in pairs(self.cuttingAreas) do
                        if foldAnimTime == nil or (foldAnimTime <= cuttingArea.foldMaxLimit and foldAnimTime >= cuttingArea.foldMinLimit) then
                            local x,y,z = getWorldTranslation(cuttingArea.start);
                            local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
                            local x2,y2,z2 = getWorldTranslation(cuttingArea.height);

                            Utils.updateMeadowArea(x, z, x1, z1, x2, z2);
                        end;
                    end;
                    for i=1, numAreas do
                        local cuttingArea = self.cuttingAreas[i];
                        if foldAnimTime == nil or (foldAnimTime <= cuttingArea.foldMaxLimit and foldAnimTime >= cuttingArea.foldMinLimit) then
                            local x,y,z = getWorldTranslation(cuttingArea.start);
                            local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
                            local x2,y2,z2 = getWorldTranslation(cuttingArea.height);

                            local ratio = g_currentMission.windrowCutLongRatio;

                            if not fruitTypeFix then
                                fruitType = FruitUtil.FRUITTYPE_GRASS;
                            end;

                            local area = Utils.updateFruitCutLongArea(fruitType, x, z, x1, z1, x2, z2, 0)/ratio;
                            area = area + Utils.updateFruitWindrowArea(fruitType, x, z, x1, z1, x2, z2, 0);
                            if area == 0 and not fruitTypeFix then
                                fruitType = FruitUtil.FRUITTYPE_DRYGRASS;
                                area = Utils.updateFruitCutLongArea(fruitType, x, z, x1, z1, x2, z2, 0)/ratio;
                                area = area + Utils.updateFruitWindrowArea(fruitType, x, z, x1, z1, x2, z2, 0);
                            end;

                            if area > 0 then
                                fruitTypeFix = true;
                            end;

                            if numDropAreas >= numAreas then
                                if area > 0 then
                                    local dropArea = self.windrowerDropAreas[i];
                                    local x,y,z = getWorldTranslation(dropArea.start);
                                    local x1,y1,z1 = getWorldTranslation(dropArea.width);
                                    local x2,y2,z2 = getWorldTranslation(dropArea.height);
                                    local old, total = Utils.getFruitWindrowArea(fruitType, x, z, x1, z1, x2, z2);
                                    area = area + old;
                                    local value = area / total;
                                    if value < 1 and value > 0.08 then
                                        value = 1;
                                    else
                                        value = math.floor(value + 0.6); -- round, biased to the bigger value
                                    end;
                                    if value >= 1 then
                                        value = math.min(value, g_currentMission.maxWindrowValue);
                                        Utils.updateFruitWindrowArea(fruitType, x, z, x1, z1, x2, z2, value, true);
										Utils.setEmittingState(self.particleSystems, true)
                                    end;
                                end;
                            end;
                        end;
                    end;

                end;
            end;

            if not self.mowerSoundEnabled and self:getIsActiveForSound() then
                setSamplePitch(self.mowerSound, self.mowerSoundPitchOffset);
                playSample(self.mowerSound, 0, self.mowerSoundVolume, 0);
                self.mowerSoundEnabled = true;
            end;
					
            self.wasToFast = toFast;
            self.wasToSlow = toSlow;


        else
            if self.mowerSoundEnabled then
                stopSample(self.mowerSound);
                self.mowerSoundEnabled = false;
            end;
           end;
        self.wasToFast = toFast;
        self.wasToSlow = toSlow;
	end;
	
	if not self.isTurnedOn then
		Utils.setEmittingState(self.particleSystems, false)
	end; 
 	if not self:isLowered(false) then
		Utils.setEmittingState(self.particleSystems, false)
	end; 
 	if not self.rotationMax1 then
		Utils.setEmittingState(self.particleSystems, false)
	end; 
	if self.wasToFast then
		Utils.setEmittingState(self.particleSystems, false)
	end; 
	if self.wasToSlow then
		Utils.setEmittingState(self.particleSystems, false)
	end; 		
    end;
	

	
	if self.rotationPart1 ~= nil then
        local x, y, z = getRotation(self.rotationPart1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart1.maxRot, self.rotationPart1.minRot, 3, self.rotationPart1.rotTime, dt, not self.rotationMax1);
        setRotation(self.rotationPart1.node, unpack(newRot));
    end;
	
	if self.rotationPart2 ~= nil then
        local x, y, z = getRotation(self.rotationPart2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart2.maxRot, self.rotationPart2.minRot, 3, self.rotationPart2.rotTime, dt, not self.rotationMax2);
        setRotation(self.rotationPart2.node, unpack(newRot));
    end;
		if self.supportstandTranslation ~= nil then
			local x, y, z = getTranslation(self.supportstandTranslation.node);
			local trans = {x,y,z};
			local newTrans = Utils.getMovedLimitedValues(trans, self.supportstandTranslation.maxRot, self.supportstandTranslation.minRot, 3, self.supportstandTranslation.rotTime, dt, self.supportstandActive);
			setTranslation(self.supportstandTranslation.node, unpack(newTrans));
		end;

		
		for i, jointDesc in pairs(self.componentJoints) do
			setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
		end;
		
		
	if self.isTurnedOn and self.rotor ~= nil then
		rotate(self.rotor, 180 * 100 * 5.9, 0, 0);
	end;
	
		if self:getIsActive() then			
		self.setHydraulicTime = 30;	
	end;

	if self.setHydraulicTime > 0 then
		for k,v in pairs(self.hydraulics) do 
			self:setHydraulicDirection(k);
		end;
		self.setHydraulicTime = self.setHydraulicTime - 1;
	end;
end;

function lelymower:draw()

    if self.isTurnedOn then
	g_currentMission:addExtraPrintText("Key B: Turn Off Rotativa Agrovil");
    else
	g_currentMission:addExtraPrintText("Key B: Turn On Rotativa Agrovil");
    end;

    if toFast then
       	setTextColor(1,0,0,1);
		renderText(0.4, 0.8, 0.029, "SLOW DOWN");
	else
		renderText(0.8, 0.4, 0.023, "");
	end;
	
	if self.help then	
	g_currentMission:addExtraPrintText("Menu: Position Key 5");
    else
	g_currentMission:addExtraPrintText("Key X: Mower Work/Transport Position");
    end;

end;

function lelymower:onDetach()

    if self.deactivateOnDetach then
        lelymower.onDeactivate(self);
    else
        lelymower.onDeactivateSounds(self)
    end;
	self.supportstandActive = true;
end;

function lelymower:onLeave()

    if self.deactivateOnLeave then
        lelymower.onDeactivate(self);
    else
        lelymower.onDeactivateSounds(self)
    end;

end;

function lelymower:onDeactivate()

    lelymower.onDeactivateSounds(self)
    self.isTurnedOn = false;

end;

function lelymower:onDeactivateSounds()

    if self.mowerSoundEnabled then
        stopSample(self.mowerSound);
        self.mowerSoundEnabled = false;
    end;

end;

function lelymower:onAttach(attacherVehicle)
	self.supportstandActive = false;
	
end;

function lelymower:setHydraulicDirection(index)
	local hydraulic = self.hydraulics[index];

	if hydraulic.fixPoint ~= nil then
		local ax, ay, az = getWorldTranslation(hydraulic.node);
		local bx, by, bz = getWorldTranslation(hydraulic.fixPoint);
		local x, y, z = worldDirectionToLocal(getParent(hydraulic.node), bx-ax, by-ay, bz-az);
		local xUp, yUp, zUp = unpack(hydraulic.upVectors);
		setDirection(hydraulic.node, x, y, z, xUp, yUp, zUp);
		if hydraulic.punch ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(hydraulic.punch, 0, 0, distance-hydraulic.punchDistance);
		end;
	end;
end;